import { useImperativeHandle, useRef, useEffect, forwardRef, memo } from 'react';
import { applyReactStyle } from "../utils/apply-react-style.js";
import useControl from "./use-control.js";

function GeolocateControl(props, ref) {
  const thisRef = useRef({
    props
  });
  const ctrl = useControl(_ref => {
    let {
      mapLib
    } = _ref;
    const gc = new mapLib.GeolocateControl(props);
    const setupUI = gc._setupUI;

    gc._setupUI = args => {
      if (!gc._container.hasChildNodes()) {
        setupUI(args);
      }
    };

    gc.on('geolocate', e => {
      var _thisRef$current$prop, _thisRef$current$prop2;

      (_thisRef$current$prop = (_thisRef$current$prop2 = thisRef.current.props).onGeolocate) === null || _thisRef$current$prop === void 0 ? void 0 : _thisRef$current$prop.call(_thisRef$current$prop2, e);
    });
    gc.on('error', e => {
      var _thisRef$current$prop3, _thisRef$current$prop4;

      (_thisRef$current$prop3 = (_thisRef$current$prop4 = thisRef.current.props).onError) === null || _thisRef$current$prop3 === void 0 ? void 0 : _thisRef$current$prop3.call(_thisRef$current$prop4, e);
    });
    gc.on('outofmaxbounds', e => {
      var _thisRef$current$prop5, _thisRef$current$prop6;

      (_thisRef$current$prop5 = (_thisRef$current$prop6 = thisRef.current.props).onOutOfMaxBounds) === null || _thisRef$current$prop5 === void 0 ? void 0 : _thisRef$current$prop5.call(_thisRef$current$prop6, e);
    });
    gc.on('trackuserlocationstart', e => {
      var _thisRef$current$prop7, _thisRef$current$prop8;

      (_thisRef$current$prop7 = (_thisRef$current$prop8 = thisRef.current.props).onTrackUserLocationStart) === null || _thisRef$current$prop7 === void 0 ? void 0 : _thisRef$current$prop7.call(_thisRef$current$prop8, e);
    });
    gc.on('trackuserlocationend', e => {
      var _thisRef$current$prop9, _thisRef$current$prop10;

      (_thisRef$current$prop9 = (_thisRef$current$prop10 = thisRef.current.props).onTrackUserLocationEnd) === null || _thisRef$current$prop9 === void 0 ? void 0 : _thisRef$current$prop9.call(_thisRef$current$prop10, e);
    });
    return gc;
  }, {
    position: props.position
  });
  thisRef.current.props = props;
  useImperativeHandle(ref, () => ctrl, []);
  useEffect(() => {
    applyReactStyle(ctrl._container, props.style);
  }, [props.style]);
  return null;
}

export default memo(forwardRef(GeolocateControl));
//# sourceMappingURL=geolocate-control.js.map