import { useEffect, memo } from 'react';
import { applyReactStyle } from "../utils/apply-react-style.js";
import useControl from "./use-control.js";

function NavigationControl(props) {
  const ctrl = useControl(_ref => {
    let {
      mapLib
    } = _ref;
    return new mapLib.NavigationControl(props);
  }, {
    position: props.position
  });
  useEffect(() => {
    applyReactStyle(ctrl._container, props.style);
  }, [props.style]);
  return null;
}

export default memo(NavigationControl);
//# sourceMappingURL=navigation-control.js.map