import * as React from 'react';
import { default as _Map } from "./components/map.js";
import { default as _Marker } from "./components/marker.js";
import { default as _Popup } from "./components/popup.js";
import { default as _AttributionControl } from "./components/attribution-control.js";
import { default as _FullscreenControl } from "./components/fullscreen-control.js";
import { default as _GeolocateControl } from "./components/geolocate-control.js";
import { default as _NavigationControl } from "./components/navigation-control.js";
import { default as _ScaleControl } from "./components/scale-control.js";
import { default as _Layer } from "./components/layer.js";
import { default as _Source } from "./components/source.js";
import { useMap as _useMap } from "./components/use-map.js";
export function useMap() {
  return _useMap();
}
const mapLib = import('maplibre-gl');
export const Map = (() => {
  return React.forwardRef(function Map(props, ref) {
    return _Map(props, ref, mapLib);
  });
})();
export const Marker = _Marker;
export const Popup = _Popup;
export const AttributionControl = _AttributionControl;
export const FullscreenControl = _FullscreenControl;
export const NavigationControl = _NavigationControl;
export const GeolocateControl = _GeolocateControl;
export const ScaleControl = _ScaleControl;
export const Layer = _Layer;
export const Source = _Source;
export { default as useControl } from "./components/use-control.js";
export { MapProvider } from "./components/use-map.js";
export default Map;
export * from "./types/public.js";
export * from "./types/style-spec-maplibre.js";
//# sourceMappingURL=exports-maplibre.js.map